package cn.net.cpzslibs.prot.handset.jinLiquor;

import com.google.gson.Gson;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.net.Socket;

import cn.net.cpzslibs.prot.ProtBase;
import cn.net.cpzslibs.prot.SocketCreate;
import cn.net.cpzslibs.prot.handset.bean.req.jinLiquor.Jin20029ReqBean;
import cn.net.cpzslibs.prot.handset.bean.res.jinLiquor.Jin20029ResBean;
import cn.net.cpzslibs.prot.utils.StrUtils;


public class Jin20029RecoverWarehouseOrder extends ProtBase {
	
	private final short iTaskCode20029 = 20029;
	private Gson gson;
	private Jin20029ResBean resBean;
	private String orderNo;
	
	public Jin20029RecoverWarehouseOrder() {
//		this.sInspectorId = sInspectorId;
		gson = new Gson();
	}
	
	public Jin20029ResBean getResBean(){
		return this.resBean;
	}
	
	public void setOrderStatus(SocketCreate create, Jin20029ReqBean reqBean) throws IOException {
		orderNo = reqBean.getOrderNo();
		recProt(create.getSocket(), create.getDos(), create.getDis(),reqBean);
	}
	
	private void recProt(Socket socket, DataOutputStream dos,
                         DataInputStream dis, Jin20029ReqBean reqBean)
			throws IOException {
		if (socket.isConnected()) {
			if (!socket.isOutputShutdown()) {
				//发送登录信息
				debugLog(iTaskCode20029, "开始请求信息");
				sendProt(dos, reqBean);
			}
		}
		if (socket.isConnected()) {
			if (!socket.isInputShutdown()) {
				recLoginDis(dis);
			}
		}
	}
	
	/**
	 * 读取JSon数据
	 * @param dis
	 * @throws IOException
	 */
	private void recLoginDis(DataInputStream dis) throws IOException {
		debugLog(iTaskCode20029, "获取接收的数据");
		recHeader(dis);
		int jsonLength = getiRecBodySize() - 2;
		String jsonData = getUTF8(dis, jsonLength);
		debugLog(iTaskCode20029, jsonData);
		if (!StrUtils.isEmpty(jsonData)) {
			resBean = gson.fromJson(jsonData, Jin20029ResBean.class);
			resBean.setOrderNo(orderNo);
		}
//		System.err.println("resBean: " + resBean.toString());
//		
		recCheckCode(dis);
	}
	
	
	/**
	 * 发送JSon数据到服务器
	 * @param dos
	 * @param iUserType
	 * @param loginBean
	 * @throws IOException
	 */
	private void sendProt(DataOutputStream dos, Jin20029ReqBean reqBean) throws IOException {
		String bodyContent = gson.toJson(reqBean);
		short bodySize = countBodySize(bodyContent);
		sendHeader(dos, iTaskCode20029, bodySize);// 84
		dos.write(bodyContent.getBytes("UTF-8"));
//		sendCheckCode(dos);
		sendCheckCoded(dos,bodyContent.getBytes("UTF-8"));
	}
	

}
